﻿using Silanis.ESL.SDK;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Web;
using WebApplication3.Models;
using WebApplication3.Utils;

namespace WebApplication3.Services
{
    public class ESLNotificationHandler
    {
        #region Process Esl Nofications

        public void ProcessEslNotification(ESLNotificationCallbackInfo eslNCBI)
        {
            switch (eslNCBI.Name)
            {
                case C.ESLCallbackNotifications.PACKAGE_CREATE:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_ACTIVATE:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_DEACTIVATE:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_READY_FOR_COMPLETION:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_COMPLETE:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_TRASH:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_RESTORE:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_DELETE:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_DECLINE:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_EXPIRE:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_OPT_OUT:
                    break;
                case C.ESLCallbackNotifications.DOCUMENT_SIGNED:
                    ProcessEslNotification_DOCUMENT_SIGNED(eslNCBI);
                    break;
                case C.ESLCallbackNotifications.ROLE_REASSIGN:
                    break;
                case C.ESLCallbackNotifications.SIGNER_COMPLETE:
                    break;
                case C.ESLCallbackNotifications.KBA_FAILURE:
                    break;
                case C.ESLCallbackNotifications.EMAIL_BOUNCE:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_ATTACHMENT:
                    break;
                case C.ESLCallbackNotifications.SIGNER_LOCKED:
                    break;
                case C.ESLCallbackNotifications.PACKAGE_ARCHIVE:
                    break;
                case C.ESLCallbackNotifications.TEMPLATE_CREATE:
                    break;
            }

        }

        private void ProcessEslNotification_DOCUMENT_SIGNED(ESLNotificationCallbackInfo eslNCBI)
        {
            EslClient eslClient = new EslClient(C.ESL.API_KEY, C.ESL.API_URL);

            DocumentPackage package1 = eslClient.GetPackage(new PackageId(eslNCBI.PackageId));
            

            //only works when role id equals to signer id
            Signer signer = eslClient.PackageService.GetSigner(new PackageId(eslNCBI.PackageId), eslNCBI.SessionUser);

            var fieldDict = new Dictionary<string, string>();

            foreach (Document document in package1.Documents)
            {
                if (document.Id.Equals(eslNCBI.DocumentId))
                {
                    List<Signature> signatureList = document.Signatures;

                    foreach (Signature signature in signatureList)
                    {

                        if (signature.SignerEmail.Equals(signer.Email))
                        {
                            List<Field> fieldList = signature.Fields;
                            foreach (Field field in fieldList)
                            {
                                String key = field.Name;
                                String value = field.Value;
                                fieldDict[key] = value;
                            }
                        }
                    }

                }
            }

            foreach (KeyValuePair<string, string> kvp in fieldDict) {

                Debugger.Log(1, "Debug", kvp.Key  +" : "+ kvp.Value+ "\n");
            }





        }



        #endregion

    }
}